# once kf5 dolphin lands, may consider disabling this -- rex
#if 0%{?fedora} < 23
%global _with_kde4 1
#endif

# After tag v0.8 with Frameworks
#define _git_describe v0.8-339-g2b34d28

Name:           kde-connect
Version:        0.9
Release:        4%{?dist}
License:        GPLv2+
Summary:        KDE Connect client for communication with smartphones

Url:            https://projects.kde.org/kdeconnect-kde
%if 0%{?_git_describe:1}
# using releaseme:
# ./tarme.rb kdeconnect-kde --origin trunk --version 0.8
# then rename accordingly
Source0:        kdeconnect-kde-%{_git_describe}.tar.xz
%else
Source0:        http://download.kde.org/unstable/kdeconnect/%{version}/src/kdeconnect-kde-%{version}g.tar.xz
%endif
Source1:        http://download.kde.org/unstable/kdeconnect/0.8/src/kdeconnect-kde-0.8.tar.xz

# firewalld service definition, see https://bugzilla.redhat.com/show_bug.cgi?id=1257699#c2
Source2:        kde-connect.xml

# Upstream patch for KDE 4 version
Patch0:         kdeconnect-kde-0.8-b-revision.patch

BuildRequires:  cmake
BuildRequires:  desktop-file-utils
BuildRequires:  extra-cmake-modules
BuildRequires:  firewalld-filesystem
BuildRequires:  kf5-rpm-macros
BuildRequires:  kf5-kcmutils-devel
BuildRequires:  kf5-kconfigwidgets-devel
BuildRequires:  kf5-kdbusaddons-devel
BuildRequires:  kf5-ki18n-devel
BuildRequires:  kf5-kiconthemes-devel
Buildrequires:  kf5-kio-devel
BuildRequires:  kf5-knotifications-devel
BuildRequires:  kf5-kwayland-devel
BuildRequires:  libXtst-devel
BuildRequires:  pkgconfig(libfakekey)
BuildRequires:  qca-qt5-devel >= 2.1.0-14
BuildRequires:  qt5-qtbase-devel
BuildRequires:  qt5-qtdeclarative-devel
BUildRequires:  qt5-qtx11extras-devel

%if %{_with_kde4}
BuildRequires:  kdelibs4-devel
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(libfakekey)
BuildRequires:  pkgconfig(QJson)
BuildRequires:  pkgconfig(qca2)
%else
Obsoletes: kde-connect-kde4-ioslave < 0.9
Obsoletes: kde-connect-kde4-libs < 0.9
%endif

Requires:       %{name}-libs%{?_isa} = %{version}-%{release}
Requires:       firewalld-filesystem
Requires:       kf5-filesystem
Requires:       fuse-sshfs
Requires:       qca-qt5-ossl
# /usr/bin/plasmawindowed (make optional at least until this is split out for bug #1286431)
Recommends:     plasma-workspace
# /usr/bin/kcmshell5
Requires:       kde-cli-tools

%description
KDE Connect adds communication between KDE and your smartphone.

Currently, you can pair with your Android devices over Wifi using the
KDE Connect app from Albert Vaka which you can obtain via Google Play, F-Droid
or the project website.

%package libs
Summary: Runtime libraries for %{name}
Requires: %{name} = %{version}-%{release}
%description libs
%{summary}.

%package devel
Summary: Development files for %{name}
Requires: %{name}-libs%{?_isa} = %{version}-%{release}
%description devel
%{summary}.

%if 0%{?_with_kde4}
%package kde4-libs
Summary: Runtime libraries for %{name} KDE4 kioslave
# circular deps, this is mostly useless without the ioslave too -- rex
Requires: %{name}-kde4-ioslave = %{version}-%{release}
%description kde4-libs
%{summary}.

%package kde4-ioslave
Summary: %{name} KDE4 kioslave
Requires: %{name}-kde4-libs%{?_isa} = %{version}-%{release}
Requires: fuse-sshfs
%description kde4-ioslave
%{summary}.
%endif


%prep
%setup -q -n kdeconnect-kde-%{version}g


%build
mkdir %{_target_platform}
pushd %{_target_platform}
%{cmake_kf5} ..
popd

make %{?_smp_mflags} -C %{_target_platform}

%if 0%{?_with_kde4}
mkdir -p  %{_builddir}/kde4
cd %{_builddir}/kde4
tar xfJ %{SOURCE1}
cd kdeconnect-kde-0.8
patch -p1 < %{PATCH0}
mkdir -p %{_target_platform}
pushd %{_target_platform}
%{cmake_kde4} ..

make %{?_smp_mflags} -C interfaces/
make %{?_smp_mflags} -C kio/
popd
%endif


%install
make install/fast DESTDIR=%{buildroot} -C %{_target_platform}

install -m644 -p -D %{SOURCE2} %{buildroot}%{_prefix}/lib/firewalld/services/kde-connect.xml

%find_lang %{name} --all-name

%if %{_with_kde4}
make install/fast DESTDIR=%{buildroot} -C %{_builddir}/kde4/kdeconnect-kde-0.8/%{_target_platform}/interfaces
make install/fast DESTDIR=%{buildroot} -C %{_builddir}/kde4/kdeconnect-kde-0.8/%{_target_platform}/kio

# Remove undesired kde4 devel files
rm -rfv %{buildroot}%{_includedir}/kde4/
rm -rfv %{buildroot}%{_libdir}/cmake/
rm -rfv %{buildroot}%{_kde4_libdir}/libkdeconnectinterfaces.so
%endif


%check
desktop-file-validate %{buildroot}%{_datadir}/applications/org.kde.kdeconnect.kcm.desktop
desktop-file-validate %{buildroot}%{_datadir}/applications/org.kde.kdeconnect.nonplasma.desktop


%post
touch --no-create %{_datadir}/icons/hicolor &> /dev/null || :
%{?firewalld_reload}

%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &> /dev/null || :

%postun
if [ $1 -eq 0 ] ; then
touch --no-create %{_datadir}/icons/hicolor &> /dev/null || :
gtk-update-icon-cache %{_datadir}/icons/hicolor &> /dev/null || :
%{?firewalld_reload}
fi

%files -f %{name}.lang
%license COPYING
%{_libexecdir}/kdeconnectd
%{_kf5_bindir}/kdeconnect-cli
%{_kf5_datadir}/plasma/plasmoids/org.kde.kdeconnect/
%{_kf5_datadir}/knotifications5/*
%{_kf5_datadir}/kservices5/*.desktop
%{_kf5_datadir}/kservices5/*.protocol
%{_kf5_datadir}/kservicetypes5/*.desktop
%{_datadir}/dbus-1/services/*.service
%{_datadir}/icons/hicolor/*/*/*
%{_datadir}/applications/org.kde.kdeconnect.kcm.desktop
%{_datadir}/applications/org.kde.kdeconnect.nonplasma.desktop
%{_qt5_prefix}/qml/org/kde/kdeconnect/
%{_qt5_prefix}/plugins/kcm_kdeconnect.so
%{_qt5_prefix}/plugins/kio_kdeconnect.so
%{_qt5_prefix}/plugins/kdeconnect*.so
%{_qt5_prefix}/plugins/kdeconnect/
%{_sysconfdir}/xdg/autostart/kdeconnectd.desktop
%{_prefix}/lib/firewalld/services/kde-connect.xml

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files libs
%{_kf5_libdir}/libkdeconnectpluginkcm.so.0*
%{_kf5_libdir}/libkdeconnectinterfaces.so.0*
%{_kf5_libdir}/libkdeconnectcore.so.0*

%if 0%{?_with_kde4}
%post kde4-libs -p /sbin/ldconfig
%postun kde4-libs -p /sbin/ldconfig

%files kde4-libs
%{_kde4_libdir}/libkdeconnectinterfaces.so.1*

%files kde4-ioslave
%{_kde4_datadir}/kde4/services/kdeconnect.protocol
%{_kde4_libdir}/kde4/kio_kdeconnect.so
%endif


%changelog
* Sat Jan 09 2016 Rex Dieter <rdieter@fedoraproject.org> 0.9-4
- kde-connect-0.9g

* Tue Dec 01 2015 Rex Dieter <rdieter@fedoraproject.org> 0.9-3
- make plasma-workspace a soft dependency (#1286431)

* Thu Nov 19 2015 Rex Dieter <rdieter@fedoraproject.org> 0.9-2
- respin kde-connect-0.9f, includes translations

* Mon Nov 16 2015 Rex Dieter <rdieter@fedoraproject.org> 0.9-1
- kde-connect-0.9 (missing translations?)

* Tue Nov 10 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8-10
- Requires: plasma-workspace kde-cli-tools (#1280078)

* Wed Sep 23 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8-9
- include kde-connect firewalld service (#1115547)

* Thu Aug 27 2015 Helio Chissini de Castro <helio@kde.org> - 0.8-8
- Added buildreq for specific qca version that has proper headers

* Wed Aug 26 2015 Rex Dieter <rdieter@fedoraproject.org> - 0.8-7
- fresh snapshot, use releaseme to include translations
- tighten subpkg deps
- .spec cosmetics

* Fri Aug 07 2015 Helio Chissini de Castro <helio@kde.org> - 0.8-6
- Added missing requires, qca-qt5-ossl. Thanks to Stefano Cavallari <spiky.kiwi@gmail.com>

* Wed Aug 05 2015 Helio Chissini de Castro <helio@kde.org> - 0.8-5
- Update the KF5 snapshot.
- Added b revision for 0.8 KDE 4
- Added requires for fuse-ssh ( thanks to Sudhir Khanger )

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Fri May 01 2015 Helio Chissini de Castro <helio@kde.org> - 0.8.3
- Added some missing buildrequires for rawhide

* Mon Apr 20 2015 Helio Chissini de Castro <helio@kde.org> - 0.8-2
- KDE Connect KF5 snapshot based on 0.8 and kioslave for KDE 4

* Sun Feb 22 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8-1
- KDE Connect 0.8 available (#1195011)
- use %%{?_kde_runtime_requires} (instead of %%_kf5_version macro)

* Thu Oct 16 2014 Rex Dieter <rdieter@fedoraproject.org> - 0.7.3-1
- kde-connect-0.7.3
- BR: libfakekey-devel (and switch other BR's to pkgconfig style)

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sun Jul 06 2014 Rex Dieter <rdieter@fedoraproject.org> 0.7.2-1
- kde-connect-0.7.2 (#1116448)

* Sun Jun 29 2014 Rex Dieter <rdieter@fedoraproject.org> 0.7.1-1
- 0.7.1

* Sat Jun 28 2014 Rex Dieter <rdieter@fedoraproject.org> - 0.7-1
- kde-connect-0.7 (#1114196)
- Requires: fuse-sshfs (#1114197)
- Requires: qca-ossl
- -libs, -devel subpkgs

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6-0.3.20140305git52901898
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed Mar 05 2014 Martin Briza <mbriza@redhat.com> - 0.6-0.2.20140305git52901898
- Include the translations too

* Wed Mar 05 2014 Martin Briza <mbriza@redhat.com> - 0.6-0.1.20140305git52901898
- Updated to the latest upstream git to match the mobile app release

* Mon Feb 24 2014 Martin Briza <mbriza@redhat.com> - 0.5-1
- New release

* Thu Jan 02 2014 Martin Briza <mbriza@redhat.com> - 0.4.2-1
- Initial package
